use utf8;
use strict;
use warnings FATAL => 'all';

package Xyzzy::Context;

use Xyzzy::Spiffy -Base;

field 'ctx', -init => 'new Xyzzy::Context::Null';
field 'cfg', -init => '$self->ctx->cfg';

sub DESTROY {} # don't try to autoload this

sub AUTOLOAD {
	my $sub = our $AUTOLOAD;
	my $off = rindex($sub, '::');
	confess "no package name in '$sub'"
		if $off == -1;
	my $pkg = substr($sub, 0, $off + 2, '');
	my $ctx = $self->ctx;
	my $code = "sub $sub { my \$self = shift; return \$self->ctx->$sub(\@_) }";
	my $err = do { local $@; eval $code; $@ };
	confess $err if $err;
	return $ctx->$sub(@_);
}

package Xyzzy::Context::Null;

use Xyzzy::Spiffy -base;

sub AUTOLOAD {
	our $AUTOLOAD;
	cluck "$AUTOLOAD called with parameters"
		if @_;
}

package Xyzzy::Context::Root;

use base 'Xyzzy::Context::Null';

field 'cfg';
field 'cgi';
