use utf8;
use strict;
use warnings FATAL => 'all';

package Xyzzy::Spiffy;

use Spiffy -base;

use Carp;

*carp = *Carp::carp;
*cluck = *Carp::cluck;
*croak = *Carp::croak;
*confess = *Carp::confess;

sub cached {
	my ($name, $_init) = @_;
	my $_package = caller;
	my $_call = ref $_init
		? '$_init->($self, @_)'
		: "do { $_init }";
	my $_code = <<EOS;
package $_package;
sub $name {
	my \$self = shift;
	return \$self->{\$name} = \$_[0] if \@_;
	return \$self->{\$name} if exists \$self->{\$name};
	return \$self->{\$name} = $_call;
}
EOS
	my $_err = do { local $@; eval $_code; $@ };
	confess $_err if $_err;
}

our @EXPORT_BASE = qw(carp cluck croak confess cached);

1
